mrrl

Minimal Reliable Reproducible Linux
git clone https://ccx.te2000.cz/git/mrrl
Log | Files | Refs | Submodules | README

ocamlbuild (6183B)


      1 #!/usr/bin/env pthbs-build
      2 #+busybox.504428034e649f598212c8994966e36667178683ec90987355f495ad3ca4abac
      3 #+busybox-bzip2.4ea548a271f41e7147568dc02e5071fb200eab38a9a22e733d3106b71e354812
      4 #+busybox-gzip.0999e8c6a8b7df82fc1cf10ade2468fb2bc4352f76d4b1d2af5099a65ccada9b
      5 #+busybox-lzop.f0d93621bfd8ca106a8590562d93158b05087e5ef48068c7a84d9967b67d2d25
      6 #+busybox-unzip.737f61aac20ef6c0554fca59bb599bf98e4fb77fbd97fba65a3692ac9d4afb84
      7 #+busybox-xz.639cf99dd37a7d6f719b937d13af92202e01adf11c130f8647574c1d9ef5b0d2
      8 #+busybox-cpio.d22266c2b6c056c0ea96873402d06591aa23368ea24d91f1fbf8a8327cb210f8
      9 #+busybox-dpkg.2b0dd2fa41e946e98f2f8948ae3d3a152a069c77460768d9c76d41f56974e514
     10 #+busybox-rpm.62bb242b4fbb3fd51b233ed9ce6c257ab997b1ee3a68ef3048656addc98f3d97
     11 #+busybox-tar.dd3d9b0075fc038df431ce2a16fc1b140de521e1aa6d154dc7b607f9403d5ac0
     12 #+busybox-ed.6ff6cd59168705c6b256d800cde7e8c69dd05c556520317dae6a0b492029fe6b
     13 #+busybox-sed.8793bcd2536ab32fa528bbb0c22f0c014663ac5e045193aa7bd113a07f58c5b9
     14 #+busybox-vi.db3d29c62845a55b7c5491d057cb9ea6c6deba93c567f4ef9eb15f06be8ad171
     15 #+busybox-xxd.9dff38f0c9dbf57856a0824bc23cc99cb31a67ce5138de7a6de2e255880a5696
     16 #+busybox-process-extra.448a35fa5362e576a23ef306ec6e0da2f625adae08cc5c3b12a01d5d28f76ce6
     17 #+busybox-procps.835712dc539d5583773d175255a5c4e27b5823d97e855948d27cc2c194247b0f
     18 #+busybox-psmisc.f2434b74cd3e07ddea335da52c222567bc111b621f0f060afef8bcc26a8d96fd
     19 #+busybox-ash.039eb4051853cdde4d03b8dbd5d6128957bf933be5ac398471666e5db0d33dab
     20 #+busybox-bc.e731e83c11906525d676777835256a3f478779eafe7152701adfc46558d73009
     21 #+busybox-coreutils.a57a12f85d58388c284d4f93f6c485d4bc2a7eac0d0f4be57b20d2ddbd4c8b8f
     22 #+busybox-coreutils-extra.09de38ce2d65026888577e8314766e4b17205b2a99a4fecfdd5cd89c1cd82aed
     23 #+busybox-daemontools.d12e277e7154028f0beaae44ad1e2c7e1cd12d28549b6861604fc634c3e09aaf
     24 #+busybox-grep.474abd8ddad6afb320c55141078cb4507d02c4610181a4d72a4d98ba93434a60
     25 #+busybox-misc.ea211db457ee098923eeff82a4388d5864254a6c2718f38471b5b2867c73d158
     26 #+busybox-sh.49a7505969c9882c8a9a7ad3f5dba6d1382add3559f4da21ceafb2708d3fd4c8
     27 #+busybox-util-linux-unpriv.95b792cd49d1f00d5488b15d93809166916ef3b8a63a69ea11f3bf6e92a74f24
     28 #+busybox-findutils.db22f512240124b15d61cf8d0ceafebc98649f6f137608a2d1bd66f18e81ad8c
     29 #+nawk.ec8a7f9ea4618a151470a1c1a0026f688a5032eb06b8e459510fe82316c17a60
     30 #+busybox-diffutils.eed6ca067c994ab56e63b8b97a60f6e9f3625d3f9aeda53306e23bb42186ce78
     31 #+musl-cross-make.4bca2cd43f4a72eaaeefc4befc0b0ce736a5906ec0245552a8db7dc56fa9e5ec
     32 #+gnu-make.fb4cff1c46827d02016d0f94d5256a263e7710025f7480fffb7580dc922a6069
     33 #+m4.3b766e732e3c57dd6ec18a8fa68d43ad094fca807d43cdcb68f8829a0c8f6905
     34 #+ocaml.bf89d3eeb0ba38f132986852f19631df96f531aa1e4f8c037f9cbcd8930f741f
     35 #@untar:-z:sha256:2ba6857f2991b7f69368e8db818b163d31cf5a367f15f5953bf8f01a77b3d4fc:.
     36 
     37 
     38 # - build script start -
     39 
     40 linker_path_mcm='/home/ccx/versions/musl-cross-make.4bca2cd43f4a72eaaeefc4befc0b0ce736a5906ec0245552a8db7dc56fa9e5ec/x86_64-linux-musl/lib/ld-musl-x86_64.so.1'
     41 linker_path_musl='/home/ccx/versions/musl.5aea4f44fd4fe9f9dd7c28a6780840121ba82303179f75a034e07f38ae99e513/library.so/ld-musl-x86_64.so.1'
     42 check_dynamic() {
     43 	local exe || true
     44 	exe=$pthbs_destdir'/home/ccx/versions'/$pthbs_package/$1
     45 	if ! test -f $exe; then
     46 		printf '%s\n' "Error: file '$1' doesn't exist!"
     47 		exit 1
     48 	fi
     49 	local interp_info || true
     50 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     51 	case $interp_info in
     52 		('')
     53 			printf '%s\n' "Error: '$1' is not a dynamic binary!"
     54 			exit 1
     55 			;;
     56 		(*"$linker_path_mcm")
     57 			return 0
     58 			;;
     59 		(*"$linker_path_musl")
     60 			return 0
     61 			;;
     62 		(*)
     63 			printf '%s\n' "Error: '$1' unexpected linker path!"
     64 			ls -l "$linker_path_mcm" "$linker_path_musl"
     65 			exit 1
     66 	esac
     67 }
     68 
     69 prefix=/home/ccx/versions/$pthbs_package
     70 dest=${pthbs_destdir%/}${prefix}
     71 cd 'ocamlbuild-0.16.1'
     72 
     73 
     74 make configure \
     75 	PREFIX="$prefix" \
     76 	OCAML_NATIVE=true \
     77 	OCAMLBUILD_BINDIR="$prefix/command" \
     78 	OCAMLBUILD_LIBDIR="$prefix/library.ocaml"
     79 
     80 
     81 make -j${JOBS:-1} -l$((1+${JOBS:-1}))
     82 
     83 # workaround ocamlbuild manpage getting installed to stdlib directory
     84 stdlib="$pthbs_destdir/home/ccx/versions/ocaml.bf89d3eeb0ba38f132986852f19631df96f531aa1e4f8c037f9cbcd8930f741f"
     85 mkdir -p "${stdlib%/*}"
     86 ln -s "$pthbs_package" "$stdlib"
     87 
     88 make DESTDIR="$pthbs_destdir" install
     89 
     90 
     91 
     92 check_dynamic command/ocamlbuild
     93 
     94 
     95 
     96 cd "$pthbs_destdir/home/ccx/versions/$pthbs_package"
     97 find -type d -o -print | awk -F/ '
     98 BEGIN {
     99 	x["./command/ocamlbuild"]=1
    100 	x["./man/man1/ocamlbuild.1"]=1
    101 }
    102 
    103 function r1(s) {
    104 	sub("^[.]/[^/]*", ".", s)
    105 	return s
    106 }
    107 function s1(repl, s) {
    108 	sub("^[.]/[^/]*", "./"repl, s)
    109 	return s
    110 }
    111 function link(src) {
    112 	x[$0]=0
    113 	printf "%s\t%s\n", $0, src
    114 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
    115 }
    116 $1!="."{exit 1}
    117 $2 == "env" { link($0); next }
    118 $2 == ".env-template" { link($0); next }
    119 
    120 $2 == "command" { link($0); next }
    121 $2 == "command" { link($0); next }
    122 $2 == "bin" { link(s1("command", $0)); next }
    123 $2 == "sbin" { link(s1("command", $0)); next }
    124 
    125 $2 == "library.so" { link($0); next }
    126 $2 == "library" { link($0); next }
    127 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
    128 $2 == "lib" && $NF ~ /\.so(\..*)?$/ { link(s1("library.so", $0)); next }
    129 
    130 $2 == "share" && $3 == "info" { link(s1("info", r1($0))); next }
    131 $2 == "share" && $3 == "man" { link(s1("man", r1($0))); next }
    132 $2 == "share" && $3 == "doc" { link(s1("doc", r1($0))); next }
    133 
    134 $2 == "config" { link($0); next }
    135 $2 == "man" { link($0); next }
    136 $2 == "info" { link($0); next }
    137 $2 == "doc" { link($0); next }
    138 $2 == "data" { link($0); next }
    139 $2 == "include" { link($0); next }
    140 
    141 $2 == "share" && $3 ~ /^(icons|terminfo)$/ { link(r1($0)); next }
    142 
    143 $2 == "library.ocaml" { link($0); next }
    144 
    145 $2 == "keys" { link($0); next }
    146 $2 == "zsh" { link($0); next }
    147 $2 == "vimfiles" { link($0); next }
    148 $2 == "icons" { link($0); next }
    149 $2 == "terminfo" { link($0); next }
    150 
    151 
    152 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    153 
    154 END {
    155 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    156 	retcode = 0
    157 	for(fname in x) {
    158 		if(x[fname]) {
    159 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    160 			retcode = 3
    161 		}
    162 	}
    163 	exit retcode
    164 }' >.install-links.new
    165 mv .install-links.new .install-links
    166